=== debian/changelog ===
crypto-policies (20190816git-1) unstable; urgency=medium

  * Initial release (Closes: #935636)
    - note: upstream releases per branch and not add release tags, so I just
      specify upstream version as <date>git, like 20190816git

 -- Hideki Yamane <henrich@debian.org>  Sat, 24 Aug 2019 21:29:22 +0900
