=== debian/control ===
Source: crypto-policies
Section: utils
Priority: optional
Maintainer: Hideki Yamane <henrich@debian.org>
Build-Depends: debhelper (>= 12~), debhelper-compat (= 12),
               asciidoc-base, xsltproc, docbook-xsl, docbook-xml,
               openssl,
               gnutls-bin (>= 3.6.0),
               bind9,
#              krb5check, (not packaged yet)
               openjdk-11-jdk-headless | java-sdk-headless,
               libfile-pushd-perl, libfile-which-perl,
Standards-Version: 4.4.0
Homepage: https://gitlab.com/redhat-crypto/fedora-crypto-policies/
Vcs-Browser: https://salsa.debian.org/debian/cypto-policies
Vcs-Git: https://salsa.debian.org/debian/cypto-policies.git
Rules-Requires-Root: no

Package: crypto-policies
Architecture: all
Depends: ${misc:Depends}, python3,
Description: unify the crypto policies used by different applications and libraries
 "crypto-policies" is a utility to unify the crypto policies used by different
 applications and libraries. The current implementations works by setting the
 desired policy in /etc/crypto-policies/config. After this file is changed
 the script 'update-crypto-policies' should be executed, and the new policies
 will activate.
 .
 The supported back ends are:
  - GnuTLS
  - OpenSSL
  - NSS
  - BIND9
  - libkrb5
  - OpenSSH
  - Java (OpenJDK)
  - libssh
  - libreswan
