=== debian/changelog ===
crypto-policies (20251128.git19878fe-0ubuntu2) resolute; urgency=medium

  * Update control to specify Architectures as "all"
  * Restructure patches for separation of concern

 -- Simon Johnsson <simon.johnsson@canonical.com>  Wed, 25 Feb 2026 09:59:12 +0100

crypto-policies (20251128.git19878fe-0ubuntu1) resolute; urgency=medium

  * Initial release. (LP: #2138940)
  * Import 20251128.git19878fe from upstream

 -- Simon Johnsson <simon.johnsson@canonical.com>  Wed, 28 Jan 2026 12:27:09 +0100
