=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with python3

override_dh_auto_install:
	dh_auto_install -- DESTDIR=$$(pwd)/debian/crypto-policies prefix=/usr

override_dh_auto_test:
	dh_auto_test --no-parallel
