=== debian/tests/control ===
Tests: test-kerberos
Depends: bats, bats-assert, krb5-admin-server, krb5-kdc, make, @
Restrictions: needs-root

Tests: test-openssl
Depends: bats, bats-assert, make, openssl, @
Restrictions: needs-root

Tests: test-openssh
Depends: bats, bats-assert, make, openssh-client, openssh-server, @
Restrictions: needs-root

Tests: test-resilience
Depends: bats, bats-assert, make, python3, @
Restrictions: needs-root

Tests: test-upstream
Depends: asciidoc,
         default-jdk,
         gnutls-bin,
         make,
         openssh-client,
         openssh-server,
         python3,
         python3-coverage,
         python3-pytest,
         @
Restrictions: needs-root allow-stderr
