=== debian/watch ===
Version: 5
Source: https://gitlab.com/redhat-crypto/fedora-crypto-policies
Compression: gz
Repack: yes
Matching-Pattern: HEAD
Mode: git
Git-Pretty: %cd.git%h
